#define NBASES 9
#define NBPAIRS 7
#define NST 0     /* Energy for nonstandard stacked pairs */
#define INF 1000000
#define K0  273.15
#define Tmeasure 310.15

static char Law_and_Order[] = "-ACGUXKIN"; /* used for finding compensatory
					 mutations */
#define ENCODE(C) (strchr(Law_and_Order, (C))==0)?0:(strchr(Law_and_Order, (C))-Law_and_Order)

static int PairMx[NBASES][NBASES]=
/* _  A  C  G  U  X  K  I  N */
{{ 0, 0, 0, 0, 0, 0, 0, 0, 0},
 { 0, 0, 0, 0, 5, 0, 0, 5, 0},
 { 0, 0, 0, 1, 0, 0, 0, 0, 0},
 { 0, 0, 2, 0, 3, 0, 0, 0, 0},
 { 0, 6, 0, 4, 0, 0, 0, 6, 0},
 { 0, 0, 0, 0, 0, 0, 2, 0, 0},
 { 0, 0, 0, 0, 0, 1, 0, 0, 0},
 { 0, 6, 0, 0, 5, 0, 0, 0, 0},
 { 0, 0, 0, 0, 0, 0, 0, 0, 0}};

static int stack37[NBPAIRS+1][NBPAIRS+1] =
/*          CG     GC     GU     UG     AU     UA  */
{ {  INF,   INF,   INF,   INF,   INF,   INF,   INF, INF},
  {  INF,  -290,  -200,  -120,  -190,  -180,  -170, NST},
  {  INF,  -340,  -290,  -140,  -210,  -230,  -210, NST},
  {  INF,  -210,  -190,   -40,   150,  -110,  -100, NST},
  {  INF,  -140,  -120,   -20,   -40,   -80,   -50, NST},
  {  INF,  -210,  -170,   -50,  -100,   -90,   -90, NST},
  {  INF,  -230,  -180,   -80,  -110,  -110,   -90, NST},
  {  INF,   NST,   NST,   NST,   NST,   NST,   NST, NST}};

/* enthalpies (0.01*kcal/mol at 37 C) for stacked pairs */
/* different from mfold-2.3, which values from mfold-2.2 */
static int enthalpies[NBPAIRS+1][NBPAIRS+1] = 
/*          CG     GC     GU     UG     AU     UA  */
{ {  INF,   INF,   INF,   INF,   INF,   INF,   INF, INF}, 
  {  INF, -1220,  -800,  -310, -1120, -1050,  -760, NST},
  {  INF, -1420, -1220,  -630,  -950, -1330, -1020, NST},
  {  INF,  -950, -1120, -2000, -1605, -1360,  -400, NST},
  {  INF,  -630,  -310, -1110, -2000,  -850,  -270, NST},
  {  INF, -1020,  -760,  -270,  -400,  -660,  -570, NST},
  {  INF, -1330, -1050,  -850, -1360,  -810,  -660, NST},
  {  INF,   NST,   NST,   NST,   NST,   NST,   NST, NST}};

/* only used for bp_together() */
static int PairSeq[NBASES][NBASES]=
/* _  A  C  G  U  X  K  I  N*/
{{ 7, 0, 0, 0, 0, 0, 0, 0, 7},
 { 0, 0, 0, 0, 5, 0, 0, 5, 7},
 { 0, 0, 0, 1, 0, 0, 0, 0, 7},
 { 0, 0, 2, 0, 3, 0, 0, 0, 7},
 { 0, 6, 0, 4, 0, 0, 0, 6, 7},
 { 0, 0, 0, 0, 0, 0, 2, 0, 7},
 { 0, 0, 0, 0, 0, 1, 0, 0, 7},
 { 0, 6, 0, 0, 5, 0, 0, 0, 7},
 { 7, 7, 7, 7, 7, 7, 7, 7, 7}};
