#ifndef _HXMATCH_H_
#define _HXMATCH_H_

/* #define DETAIL */
#define MAX_NUM_NAMES    500
#define BONUS 1
#include "list.h"
typedef struct {
  unsigned short bi;
  unsigned short bj;
  int wt, owt; /* weight and original weight */
  short ptyp[9];    /* frequencies of pair_types, 0=incomp bases,
		      7=gap-gap and N-(base | N | gap), 8=gap-base */
  short col[2];
  short xx; /* 1=inside 2=beginning 3=end of a stack */
  int rm; /* number of rematches */
  short comp; /* number of compatible sequences */
  short mut; /* number of compensatory mutations */
  int hx;  /* the number of the helix of that bp */
  short hh[50];
  short out; /* output without MWM */
  list *helices;
} INFO;

typedef struct {
  int bi;
  unsigned short bj;
  int wt; /* weight */
} BASINF;


#ifdef PRODEF
#define EXT
#else
#define EXT extern
#endif


EXT INFO *helix(int h_len);
EXT INFO *alif(FILE *file);
EXT INFO *alp(FILE *file);
EXT INFO *ext_pairs(FILE *file);
EXT INFO *dotplot(void);
EXT void read_clustal(FILE *clust);
EXT INFO *mix_bpairs(INFO *pfrali_bp, INFO *bpairs);
EXT INFO *constraints(FILE *cons, INFO *bpairs);
EXT void bpair2helix(INFO *bpairs);
EXT INFO *choose_bp(INFO *bpairs);
EXT INFO *cset_info(INFO *inf, int f, int p);
EXT void no_mwm(INFO *bpairs);
EXT void print_cook(INFO *bpairs);
EXT void print_roth(INFO *bpairs);
EXT void print_mwm(INFO *outcom);

EXT char *Aln_seqs[MAX_NUM_NAMES];          /* aligned sequences */
EXT char *Cons_seq;  /*consenus sequence */
EXT char *Names[MAX_NUM_NAMES];   /* sequence names */
EXT char *Struc;
EXT int Nbp, Pnbp, Min_comp, Nseq;
EXT int temp, it;
EXT int K;
EXT int phi2, AA, Pi_star;
EXT float phi1, P_min;
EXT int af, ap, w, dp, csr;
EXT int Stop;
EXT int DW, MW;
EXT int Tresh, nomwm, PTresh;


EXT INFO *outcom;

#undef EXT
#endif
