/* Last changed Time-stamp: <2003-12-10 14:27:27 xtina> */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "xutils.h"
#include "hxmatch.h"
#include "read_graph.h"

/********************************************************************/
void print_mwm(INFO *outcom){
  int i;
  FILE *file;
  file = fopen("hxm.mwm", "w");
  for(i=0; i<K; i++) {
    fprintf(file, "%d %d\n", outcom[i].bi, outcom[i].bj);
  }
  fclose(file);
  
  file = fopen("hxmw.mwm", "w");
  for(i=0; i<K; i++) {
    fprintf(file, "%d %d %d\n", outcom[i].bi, outcom[i].bj, outcom[i].wt);
  }
  fclose(file);
  
  
}

/********************************************************************/

void print_cook(INFO *bpairs) {

  int i, max_wt, M;
  int j, ii, jj, wt;
  int **matrix;
  FILE *file;

  file = fopen("hxm.4cook", "w");

  if(V%2)
    fprintf(file, "%d %d\n", V+1, ((V+1)*V/2));
  else
    fprintf(file, "%d %d\n", V, (V*(V-1)/2));
    
  max_wt = 0;
  for(i = 0; i < Nbp; i++) {
    if(bpairs[i].wt > max_wt)
      max_wt = bpairs[i].wt;
  }
  
  M = max_wt+2;

 if(!(matrix =  (int **)calloc((V+1), sizeof(int *)))) {
    fatal("print_roth(): allocation of **matrix failed!!!");
  }

  for(i=1; i<=V; i++) {
    if( !(matrix[i] = (int *)calloc((V+1), sizeof(int)) ) ) {
      fatal("print_roth(): allocation of matrix[i] failed!!!");
    }
  }
  
  for(i=0; i<Nbp; i++) {
    ii = bpairs[i].bi;
    jj = bpairs[i].bj;
    wt = bpairs[i].wt;
    matrix[ii][jj] = wt;
    matrix[jj][ii] = wt;
  }

  for(i=1; i<=V; i++) {
    for(j=i+1; j<=V; j++) {
      if(matrix[i][j]) {
	fprintf(file, "%d %d %d\n", i-1, j-1, M-matrix[i][j]);
      }
      else {
	fprintf(file, "%d %d %d\n", i-1, j-1, M);
      }
    }
  }
  
  if(V%2) {
    for(i = 0; i < V; i++) {
      fprintf(file, "%d %d %d\n", i, V, M);
    }
  }
 
  
  fclose(file); 
  return;
}

/********************************************************************/

void print_roth(INFO *bpairs) {

  int i, j, ii, jj, wt, adj;
  FILE *file;
  int **matrix;
 
  file = fopen("hxm.4roth", "w");
  fprintf(file, "%d %d U\n", V, Nbp);


  if(!(matrix =  (int **)calloc((V+1), sizeof(int *)))) {
    fatal("print_roth(): allocation of **matrix failed!!!");
  }

  for(i=1; i<=V; i++) {
    if( !(matrix[i] = (int *)calloc((V+1), sizeof(int)) ) ) {
      fatal("print_roth(): allocation of matrix[i] failed!!!");
    }
  }
  
  for(i=0; i<Nbp; i++) {
    ii = bpairs[i].bi;
    jj = bpairs[i].bj;
    wt = bpairs[i].wt;
    matrix[ii][jj] = wt;
    matrix[jj][ii] = wt;
  }

  for(i=1; i<=V; i++) {
    adj = 0;
    for(j=1; j<=V; j++) {
      if(matrix[i][j]) adj++;
      }
    fprintf(file, "%d %d 0 0\n", adj, i);
    for(j=1; j<=V; j++) {
      if(matrix[i][j]) {
	fprintf(file, "%d %d\n", j, matrix[i][j]);
      }
    }
  }
  for(i=1; i<=V; i++) {
    free(matrix[i]);
  }
  free(matrix);
  fclose(file); 
  return;
}
