#ifndef _MATCH_H_
#define _MATCH_H_

#define BEND(e) (BASE[END[e]])/* the number of the blossom entered by edge e */
#define BMATE(v) (BASE[END[MATE[v]]])/* the blossom matched with v's blossom */
#define BLINK(v) (BASE[END[LINK[v]]])/* the blossom entered by the edge that links v's blossom */
#define OPPEDGE(e) (((e - V) % 2 == 0) ? (e - 1) : (e + 1))/* the edge e with it's direction reversed */
#define SLACK(e) (Y[END[e]] + Y[END[OPPEDGE(e)]] - WEIGHT[e])/* the slack of edge e */



#ifdef PRODEF
#define EXT
#else
#define EXT extern
#endif


/* Global variables */
EXT int *NEXTPAIR;
EXT int *LINK, *BASE, *NEXTVTX, *LASTVTX, *Y, *NEXT_D, *NEXTEDGE;
EXT int LAST_D, DELTA;
EXT int LASTEDGE[3];
EXT int DUMMYVERTEX, DUMMYEDGE;
EXT int newbase, oldbase, nextbase,  pairpoint;
EXT int neighbor, nextpoint, newlast;
EXT int newmate, oldmate, oldfirst, firstmate, secondmate;
EXT int f, nextedge, nexte, nextu;
EXT int v, e;

/* Functions */
EXT void POINTER(int u, int v, int e);
EXT void SCAN(int x, int del);
EXT int PAIR(void);
EXT void MERGE_PAIRS(int v);
EXT void LINK_PATH(int e);
EXT void INSERT_PAIR(void);
EXT void UNPAIR(int oldbase, int oldmate);
EXT void UNLINK(int oldbase);
EXT void REMATCH(int firstmate, int e);
EXT void SET_BOUNDS(void);
EXT void UNPAIR_ALL(void);

#undef EXT
#endif
