#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define PRODEF
#include "xutils.h"
#undef PRODEF

void fatal(const char *s) {
  perror(s);
  exit(1); 
}

char *getline(FILE *fp) {
  
  char s[512], *line, *cp;
  
  line = NULL;
  do {
    if (fgets(s, 512, fp) == NULL) break;
    cp = strchr(s, '\n');
    if (cp != NULL) *cp = '\0';
    if (line == NULL) {
      if(!(line = calloc((strlen(s) + 1), sizeof(char)))) {
	fatal("getline(): allocation of line failed!!!");
      }
    }
    else {
      if(!(line = (char *)realloc(line, strlen(s) + strlen(line) + 1))) {
	fatal("getline(): reallocation of line failed!!!");
      }
    }
    strcat(line, s);
  } while(cp == NULL);

  return(line);
}


